<template>
  <div v-if="showButton && allowRoute" class="relative">
    <div
      class="flex flex-col items-center gap-2 cursor-pointer fixed z-50 py-[12px] px-[8px] align-middle rounded-lg right-[80px] bottom-3 entry-gif-btn"
      :class="{
        __mobile: isMobile,
        __hasLiveChat: hasLiveChat || hasFacebookLink,
        '!pb-[140px]':
          (!hiddenTalkId && getTalkId.Text && hasLiveChat) || hasFacebookLink,
      }"
      @click="onClickEntryButton"
    >
      <img
        class="entry-button"
        :src="getAssetImage('assets/theme/common/lucky-wheel/entry-button.gif')"
        alt=""
      />
      <span v-if="!isMobile" style="font-size: 20px; font-weight: 700">{{
        $t("Lucky Wheel")
      }}</span>
      <SvgIcon
        class="absolute right-0 top-0 h-6 w-6"
        svg-name="outline-x-mark"
        @click.stop="showButton = false"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";
import { store } from "~~/store";

type propsType = {
  dialogVisible: boolean;
  homepageEntrance: boolean;
};
const props = defineProps<propsType>();
const emits = defineEmits(["update:dialogVisible"]);
const onClickEntryButton = () => {
  emits("update:dialogVisible", true);
};
const { getAssetImage } = commonHelper;
const isPlayful = computed(() =>
  store.state.selectedThemeName.includes("playful")
);
const isMobile = !useIsDesktop();
const hasLiveChat = ref(false);
const hasFacebookLink = ref(false);
let retryTime = 0;
const intervalToFindLivechat = setInterval(() => {
  retryTime += 1;
  const livechatEl = document.querySelector(".tawk-mobile");
  const facebookLinkEl = document.querySelector(".facebook-link-animate");
  if (livechatEl) {
    hasLiveChat.value = true;
    clearInterval(intervalToFindLivechat);
  }
  if (facebookLinkEl) {
    hasFacebookLink.value = true;
    clearInterval(intervalToFindLivechat);
  }
  if (!hasLiveChat.value || retryTime === 6) {
    clearInterval(intervalToFindLivechat);
  }
}, 1300);
const showButton = ref(true);
const route = useRoute();
const { isIndependentModule } = useIndependentModule();
const allowRoute = computed(() => {
  if (props.homepageEntrance === undefined) return route.name === "index";
  if (route.name === "index") return props.homepageEntrance;
  if (route.name === "sports" && isIndependentModule.value) {
    return props.homepageEntrance;
  }
  return false;
});
const hiddenTalkId = ref(false);
const getTalkId = computed(() =>
  featuresToggleHelper.getThemePropertyFromApi(
    EnumThemePropertyKey.HtmlId,
    "tawkid"
  )
);
hiddenTalkId.value = getTalkId.value.IsHidden;
</script>

<style lang="scss">
.entry-gif-btn {
  img {
    width: 120px;
    height: 120px;
  }
  &.__mobile {
    right: 0;
    bottom: 9%;
    &.__hasLiveChat {
      padding-bottom: 68px;
    }
    img {
      width: 72px;
      height: 72px;
    }
  }
}
</style>
